<?PHP 
//save_session_path('/home/groups/f/fr/free-cmms/sessions');
include('config.inc.php');
session_save_path($session_save_path);
session_start();

$url = sprintf("%s%s%s","http://",$HTTP_HOST,$REQUEST_URI);
$_SESSION['last_query'] = $url;

if(empty($_GET['query_name']) && empty($_SESSION['query_name']) && !empty($_SESSION['group']))
{
  exit;
}

if(!empty($_GET['query_name'])) //save the query name as a session var
{
  $_SESSION['query_name'] = $_GET['query_name'];
  unset($_GET['query_name']);
}

include("./libraries/Table.php"); //this is the class for HTML tables
include("./libraries/browser.inc.php"); //detect the browser
include("./styles/dynamic_css.php");    //set up font sizes, etc per browser

/*
 *Get the table sql statement, title, and column attributes from the database
 *
 * @param    string   the name of the table blueprint to retrieve
 *
 * @return   object   mysql query result result 
 */
 
function get_table_blueprint($gtb_name)
{

  $blueprint_sql = "SELECT * FROM queries WHERE name like '$gtb_name'";

  $blueprint_sql_result = mysql_query($blueprint_sql) or die("Query failed. Copy the following information to an email to $admincontact : <br> $blueprint_sql");

  if(mysql_num_rows($blueprint_sql_result) != 1)
    {
      echo "I either forgot or I never was told how to retireve the informatio you want.<br>
            Copy everything between the lines and email it to $admincontact
            <hr>
            url: $url <br>
            query_name: " . $_REQUEST['query_name'] . " <br>
            query_sql: $blueprint_sql <br>
            <hr>";
      exit;
    }
  
  $gtb_table = mysql_fetch_object($blueprint_sql_result);

  //Some queries include php variables such as $_SESSION['last_login']
  //for showing activity since a users last login.
  //This code evaluates the sql string, replacing such variables with
  //proper values, then stores the new sql over the old one.

  //debug echo "<HR>The sql pulled from the database is:<br><pre>$gtb_table->sql</pre>";
  eval('$gtb_table->sql = "' . $gtb_table->sql . '" ;');
  //debug  echo "<HR>The new sql is:<br><pre>$gtb_table->sql</pre>";
  $gtb_table->col_attributes = unserialize($gtb_table->col_attributes); //turn the serialized column attributes back into
                                                                    //an array

  /*
   *Parse the table->sql statement and get the column head names.
   *The heads are those fields in the sql statement that are aliased.
   * e.g. 
   *
   *    SELECT foo AS 'Wonderful Foo', 
   *           bar AS 'Fantastic Bar', 
   *           zonk 
   *           FROM elbat;
   *
   *   Results in a table like this:
   *
   *   +---------------+---------------+
   *   | Wonderful Foo | Fantastic Bar |
   *   +---------------+---------------+
   *
   *   Note zonk is not displayed because it was not aliased
   *   The script is intelligent enough to ignore aliased table names
   */

  $fields = substr($gtb_table->sql, 0, strpos($gtb_table->sql, ' FROM')); //Chop everything after the word 'FROM' off of the SQL

  $needle = "|.*AS '(.*)'|U"; //Regexp to match all aliases

  preg_match_all($needle, $fields, $col_names, PREG_PATTERN_ORDER ); //Store the aliases in the array '$col_names'

  $gtb_table->col_names = $col_names[1]; //make the array of column names a property of our table for consistency


  /*
   *Modify the column names so that will come out as hyperlinks to sort the table
   *The actual HTML links will be added to the table as $table->col_links.
   */
  $keys = array_keys($gtb_table->col_names);

  $gtb_table->col_link = array();

  foreach( $keys as $key)
    {
      $col = $gtb_table->col_names[$key];

      $gtb_table->col_link[$key] = "<a href=" . $_SERVER['PHP_SELF'] . "?order_by=" . urlencode($col) . ">$col</a>";
    }

  $_SESSION['view_title'] = $gtb_table->title;

  return $gtb_table;

} //end function get_table_blueprint


/*
 *Filter out the columns that we do not want
 *e.g.
 *if $table->sql was:
 *   $table->sql = SELECT foo AS 'Wonderful Foo', 
 *                 bar AS 'Fantastic Bar', 
 *                 zonk 
 *                 FROM elbat;
 *
 *then $all_rows would be something like:
 *   $all_rows = +---------------+---------------+------+
 *               | Wonderful Foo | Fantastic Bar | zonk |
 *               +---------------+---------------+------+
 *               | 1             | 2             | 3    |
 *               +---------------+---------------+------+
 *               | a             | b             | c    |
 *               +---------------+---------------+------+
 *               | j             | 4             | 7    |
 *               +---------------+---------------+------+
 *
 *$table->col_names = {'Wonderful Foo', 'Fantastic Bar'}
 *
 * So we go through $all_rows and copy the 'Wonderful Foo' and 'Fan Bar' fileds 
 * to a new set of rows called '$rows'...this is done one row at a time. We end up with
 *   $rows     = +---------------+---------------+
 *               | Wonderful Foo | Fantastic Bar |
 *               +---------------+---------------+
 *               | 1             | 2             |
 *               +---------------+---------------+
 *               | a             | b             |
 *               +---------------+---------------+
 *               | j             | 4             |
 *               +---------------+---------------+
 *
 * Note that PHP has a function to get the intersection of two array's values or values and keys but not
 * keys alone. Nor could I find a way to delete all keys specified in a multi dimensional array. I think 
 * Perl can do this.
 */
function purge_columns($pc_all_rows, $pc_table)
{

  $i=0;

  foreach($pc_all_rows as $ele) //iterate through each record returned
    { 
      $pc_rows[$i] = array();

      foreach($pc_table->col_names as $column) //iterate through each column of each record
	{
	  array_push($pc_rows[$i], $ele[$column]); //for each col_name copy the column to a new array 'rows'
	 
	}
      $i++;
    }
  return $pc_rows;
} //end function purge_columns

/*
 *Modifies the SQL statement to sort the table by the given column
 *
 */
function order_by($ob_sql, $ob_col)
{

  if(stristr($ob_sql, 'ORDER BY')) //if there already is an order by cluase
  {
    $first = substr($ob_sql, 0, strpos($ob_sql, 'ORDER BY')); //Chop everything after 'ORDER BY';

    $regexp = "/ORDER BY.*(ASC|DESC)(.*)/";

    if(preg_match($regexp, $ob_sql, $end))
    {
      $last = $end[2];
    }
 
       $sql = $first . " ORDER BY $ob_col " . $last;
      
  }
  else
    {
      $sql = $ob_sql . " ORDER BY '$ob_col'";
    }

  return $sql;
}     
  ?>

<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">

<html>
<head>

    <meta http-equiv="content-type" content="text/html; charset=ISO-8859-1">
  
    <title>View work order table</title>
 
	<!-- Include style sheet to make web form similar to paper form --> 


<?PHP 

css_site("nicetable.css");               //customize the style sheet for the current browser and platform
                        
?>
	
    <script src="./libraries/functions.js" type="text/javascript" language="javascript"></script>

</head>



<?PHP



/*
 *If the user is not logged in then present them with a login form
 */

if(!isset($_SESSION['group']))
{
?>
<body "background-color:#FFFFFF;" >
<div id="centerbox">
<p>
    <form action="auth.php" method="POST" class="form">

    <table align="center">
        <tr>
            <td colspan="2" align="center"><h2 style="color:red;">Please Log In</h2></td>
        </tr>
    
        <tr>
            <td>Login:</td>
            <td>Password:</td>
        </tr>
    
        <tr>
            <td><input type="text" name="uid" class="input" size="10"></td>
    	<td><input type="password" name="passwd" class="input" size="10"></td>
        </tr>
    
        <tr>
            <td colspan="2" align="center"><input type="submit" value="Login"></td>
        </tr>
    </table>
    </p>
    </div>
    </body>
    </html>


<?PHP

  exit;
}


/*Connect to the database */  
$connection=mysql_connect($hostName,$userName,$password) or die('Could not connect to the database server');
$db = mysql_select_db($databaseName, $connection) or die ("Unable to select database.");

/**
 *This is a bit trick so try to keep up...
 *Each table of work orders/request has everything about it stored
 *in a table in the maintenance database. Here's how it works: the variable '$_REQUEST['query_name']'
 *is passed to this script. The script looks in the database in the 'queries' table for a
 *match between the query name and the value of '$_REQUEST['query_name']'. Did you get that? If I ask
 *for all work order to be displayed, the value of '$_REQUEST['query_name']' will be WO_ALL. This script
 *looks in the table 'queries' and finds 'WO_ALL'. It then gets the SQL statement associated
 *with 'WO_ALL'. When that sql statement is run on the database, it returns all work orders.
 *Each record in the 'queries' table also has an array of column attributes for centering text,
 * setting column width, etc. This array is stored by using the PHP serialize() and unserialize() functions. The 
 * table headers are encoded in the returned SQL statement. More on that 
 *later
 **/

$table = get_table_blueprint($_SESSION['query_name']) or die('Could not create table. Email $admincontact '); //get the table blueprint

if(!empty($_GET['order_by'])) //if a column head was clicked then we need to sort the table by that column.
{
$table->sql = order_by($table->sql, $_GET['order_by']);
}

if(isset($admin) && strpos($table->sql, "LIMIT") === FALSE) //if we are admin and there is not already a limit statement
{
  $table->sql .= " LIMIT 0 ,2";
}

$sql_result = mysql_query($table->sql,$connection) or die ("Query failed: <br> $table->sql"); //execute the retrieved SQL

$num_results = mysql_num_rows($sql_result);

if($num_results == 0)
{
  echo "<h2>Please select list from the navigation pane on the left.</h2>";
  exit;
}

$all_rows = array(); //store the results in the array $all_rows

while($op_row = mysql_fetch_array($sql_result, MYSQL_ASSOC))  //store the resulting records as an array
{
  array_push($all_rows, $op_row);
}

$rows = purge_columns($all_rows, $table); //purge the unwanted (i.e. unaliases) columns


$table_prop = array('border'     => '0', 
		    'cellpadding'=> '5'); //attributes for the table

$data_table = new HTML_Table($table_prop);


$arr_head_attr = array(''=>''); //header attributes

/*
 *if(ereg("^Mozilla.*",$HTTP_USER_AGENT)) //If the user is using a Geko based browser scroll only the table body
 *{
 *$html .= "$ STYLE=\"overflow: auto; height: 400px;\"";
 *}
 */

$test = TRUE;
$i    = 1;

$data_table->addRow($table->col_link,$row_attr, 'TH'); //add the column names as header cells to the table


foreach($rows as $row)
{

  /*
   *Populate the rows of data
   *
   */

  $test = !$test; //toggle the value of test

  $bg = ($test) ? "#CCCCCC" : "#DDDDDD"; //set the background color of the row
 
  //a bit of javascript to highlight rows as they are moused over and clicked upon
  $row_attr = array('onmouseover' => "setPointer(this, $i, 'over', '$bg', '#CCFFCC', '#FFCC99');",
                    'onmouseout'  => "setPointer(this, $i, 'out', '$bg', '#CCFFCC', '#FFCC99');",
                    'onmousedown' => "setPointer(this, $i, 'click', '$bg', '#CCFFCC', '#FFCC99');");   

 
  //add an edit and print icon for each work order
  $print_icon = '<img src="./images/print.png" alt="Print Work Order" height="22px" width="22px" border="0">';
  $edit_icon  = '<img src="./images/view-edit.png" alt="Edit Work Order" height="22px" width="22px" border="0">';


  switch($table->mode)
    {
    case 'work_order':
  $print_link = "<a href=\"print.php?wo_id=$row[0]\" target=\"print_window\" title=\"Print this work order\">$print_icon</a>";
  $edit_link  = "<a href=\"javascript://\" onClick=\"openwindow($row[0])\" title=\"View & edit thie work order\">$edit_icon</a>";
  break;

    case 'hot_job':
  $edit_link  = "<a href=\"javascript://\" onClick=\"openwindow_hj($row[0])\" title=\"View & edit thie work order\">$edit_icon</a>";
  break;
    }

  $row[0] = $row[0] . "<br>" . $edit_link . "&nbsp&nbsp" .  $print_link;    
                

  $new_row = $data_table->addRow($row,$row_attr, 'TD', TRUE);

  $cell_attr = array('bgcolor' => "$bg",
		     'valign'  => 'top');

  $data_table->setRowAttributes($new_row, $cell_attr, FALSE);

  $i++;

} 

$num_cols = $data_table->getColCount();

for($i = 0; $i < $num_cols; $i++)
{
  $data_table->updateColAttributes($i, $table->col_attributes[$i]);
}

$table_html = $data_table->toHtml();

if(isset($admin))
{

$admin_table = new HTML_Table($table_prop);

$admin_table->addRow($table->col_names,$row_attr, 'TH');

 $attr_form = array();

for($i = 0; $i < $num_cols; $i++)
{
  $admin_table->updateColAttributes($i, $table->col_attributes[$i]);

  $keys = array();
  $keys = array_keys($table->col_attributes[$i]);

  for($j=0; $j < 3; $j++)
    {
      $keyname    = "key"   . $i . "[]";
      $valuename  = "value" . $i . "[]";
      $keyvalue   = $keys[$j];
      $valuevalue = $table->col_attributes[$i][$keyvalue];

      $attr_form[$i] .= "<input type='text' name='$keyname' value='$keyvalue'>=<input type='text' name='$valuename' value='$valuevalue'><hr>\n" ;
    }

  
}
  $attr_form[$num_cols] .= "<input type='hidden' name='cols' value='$num_cols'>";
  $attr_form[$num_cols] .= "<input type='hidden' name='url' value='" . $_SERVER['PHP_SELF'] . "'>";
  $attr_form[$num_cols] .= "<input type='hidden' name='qry_name' value='" . $_REQUEST['query_name'] ."'>";
  $submit_html = "<input type='submit' name='save'>";

  $admin_table->addRow($attr_form);

  $admin_table_html = $admin_table->toHtml();

  $virgin_table = get_table_blueprint($_REQUEST['query_name']) or die('Could not create table. Email $admincontact'); //get a virgin copy of the table sql

  $sql_text_html = "<textarea name=\"sql_query\" cols=\"80\" rows=\"7\">$virgin_table->sql</textarea>";

  $admin_table_html .= "<hr>" . $sql_text_html . $submit_html;
}

$nav_title = urlencode($table->title);


?>
<body  onLoad='javascript:top.title.location.href="title.php?title=<?=$nav_title ?>";' >
   
   <?PHP echo $table_html; ?>
    <hr>
    Click on any column heading to sort by that column.
    <br> Click on the work order number to edit the details of that work order.
    <br> Click on the print icon to print a work order.<hr>
<form action='edit_query.php' method='post'>
    <?PHP   echo $admin_table_html ?>
</form>
<div style="text-align:center;"><a  href = '<?PHP echo $_SERVER['PHP_SELF']?>?admin=1'>edit table</a></div>
</body>
</html>

<?PHP //tags so that emacs mmm-php mode works
?>





 

 